# encoding: utf-8
# module mimetools
# from /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/mimetools.pyo by generator 1.99
""" Various tools used by MIME-reading or MIME-writing programs. """

# imports
import tempfile as tempfile # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/tempfile.pyc
import rfc822 as rfc822 # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/rfc822.pyc
import sys as sys # <module 'sys' (built-in)>
import os as os # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/os.pyc

# Variables with simple values

uudecode_pipe = '(\nTEMP=/tmp/@uu.$$\nsed "s%^begin [0-7][0-7]* .*%begin 600 $TEMP%" | uudecode\ncat $TEMP\nrm $TEMP\n)'

_counter = 0

_prefix = None

# functions

def choose_boundary(): # reliably restored by inspect
    """
    Return a string usable as a multipart boundary.
    
        The string chosen is unique within a single program run, and
        incorporates the user id (if available), process id (if available),
        and current time.  So it's very unlikely the returned string appears
        in message text, but there's no guarantee.
    
        The boundary contains dots so you have to quote it in the header.
    """
    pass


def copybinary(input, output): # reliably restored by inspect
    # no doc
    pass


def copyliteral(input, output): # reliably restored by inspect
    # no doc
    pass


def decode(input, output, encoding): # reliably restored by inspect
    """ Decode common content-transfer-encodings (base64, quopri, uuencode). """
    pass


def encode(input, output, encoding): # reliably restored by inspect
    """ Encode common content-transfer-encodings (base64, quopri, uuencode). """
    pass


def filterwarnings(action, message=None, category="<type 'exceptions.Warning'>", module=None, lineno=0, append=0): # reliably restored by inspect
    """
    Insert an entry into the list of warnings filters (at the front).
    
        'action' -- one of "error", "ignore", "always", "default", "module",
                    or "once"
        'message' -- a regex that the warning message must match
        'category' -- a class that the warning must be a subclass of
        'module' -- a regex that the module name must match
        'lineno' -- an integer line number, 0 matches all warnings
        'append' -- if true, append to the list of filters
    """
    pass


def pipethrough(input, command, output): # reliably restored by inspect
    # no doc
    pass


def pipeto(input, command): # reliably restored by inspect
    # no doc
    pass


def warnpy3k(message, category=None, stacklevel=1): # reliably restored by inspect
    """
    Issue a deprecation warning for Python 3.x related changes.
    
        Warnings are omitted unless Python is started with the -3 option.
    """
    pass


def _get_next_counter(): # reliably restored by inspect
    # no doc
    pass


# classes

class catch_warnings(object):
    """
    A context manager that copies and restores the warnings filter upon
        exiting the context.
    
        The 'record' argument specifies whether warnings should be captured by a
        custom implementation of warnings.showwarning() and be appended to a list
        returned by the context manager. Otherwise None is returned by the context
        manager. The objects appended to the list are arguments whose attributes
        mirror the arguments to showwarning().
    
        The 'module' argument is to specify an alternative module to the module
        named 'warnings' and imported under that name. This argument is only useful
        when testing the warnings module itself.
    """
    def __enter__(self, *args, **kwargs): # real signature unknown
        pass

    def __exit__(self, *args, **kwargs): # real signature unknown
        pass

    def __init__(self, *args, **kwargs): # real signature unknown
        """
        Specify whether to record warnings and if an alternative module
                should be used other than sys.modules['warnings'].
        
                For compatibility with Python 3.0, please consider all arguments to be
                keyword-only.
        """
        pass

    def __repr__(self, *args, **kwargs): # real signature unknown
        pass

    __weakref__ = property(lambda self: object()) # default

    __dict__ = None # (!) real value is ''


# variables with complex values

decodetab = {
    'base64': 'mmencode -u -b',
    'quoted-printable': 'mmencode -u -q',
    'uue': '(\nTEMP=/tmp/@uu.$$\nsed "s%^begin [0-7][0-7]* .*%begin 600 $TEMP%" | uudecode\ncat $TEMP\nrm $TEMP\n)',
    'uuencode': '(\nTEMP=/tmp/@uu.$$\nsed "s%^begin [0-7][0-7]* .*%begin 600 $TEMP%" | uudecode\ncat $TEMP\nrm $TEMP\n)',
    'x-uue': '(\nTEMP=/tmp/@uu.$$\nsed "s%^begin [0-7][0-7]* .*%begin 600 $TEMP%" | uudecode\ncat $TEMP\nrm $TEMP\n)',
    'x-uuencode': '(\nTEMP=/tmp/@uu.$$\nsed "s%^begin [0-7][0-7]* .*%begin 600 $TEMP%" | uudecode\ncat $TEMP\nrm $TEMP\n)',
}

encodetab = {
    'base64': 'mmencode -b',
    'quoted-printable': 'mmencode -q',
    'uue': 'uuencode tempfile',
    'uuencode': 'uuencode tempfile',
    'x-uue': 'uuencode tempfile',
    'x-uuencode': 'uuencode tempfile',
}

Message = None # (!) real value is ''

_counter_lock = None # (!) real value is ''

__all__ = [
    'Message',
    'choose_boundary',
    'encode',
    'decode',
    'copyliteral',
    'copybinary',
]

