# encoding: utf-8
# module mimify
# from /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/mimify.pyo by generator 1.99
"""
Mimification and unmimification of mail messages.

Decode quoted-printable parts of a mail message or encode using
quoted-printable.

Usage:
        mimify(input, output)
        unmimify(input, output, decode_base64 = 0)
to encode and decode respectively.  Input and output may be the name
of a file or an open file object.  Only a readline() method is used
on the input file, only a write() method is used on the output file.
When using file names, the input and output file names may be the
same.

Interactive usage:
        mimify.py -e [infile [outfile]]
        mimify.py -d [infile [outfile]]
to encode and decode respectively.  Infile defaults to standard
input and outfile to standard output.
"""

# imports
import re as re # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/re.pyc
import warnings as warnings # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/warnings.pyc
import sys as sys # <module 'sys' (built-in)>

# Variables with simple values

CHARSET = 'ISO-8859-1'

MAXLEN = 200

QUOTE = '> '

# functions

def mime_decode(line): # reliably restored by inspect
    """ Decode a single line of quoted-printable text to 8bit. """
    pass


def mime_decode_header(line): # reliably restored by inspect
    """ Decode a header line to 8bit. """
    pass


def mime_encode(line, header): # reliably restored by inspect
    """
    Code a single line as quoted-printable.
        If header is set, quote some extra characters.
    """
    pass


def mime_encode_header(line): # reliably restored by inspect
    """ Code a single header line as quoted-printable. """
    pass


def mimify(infile, outfile): # reliably restored by inspect
    """ Convert 8bit parts of a MIME mail message to quoted-printable. """
    pass


def mimify_part(ifile, ofile, is_mime): # reliably restored by inspect
    """ Convert an 8bit part of a MIME mail message to quoted-printable. """
    pass


def unmimify(infile, outfile, decode_base64=0): # reliably restored by inspect
    """ Convert quoted-printable parts of a MIME mail message to 8bit. """
    pass


def unmimify_part(ifile, ofile, decode_base64=0): # reliably restored by inspect
    """ Convert a quoted-printable part of a MIME mail message to 8bit. """
    pass


# no classes
# variables with complex values

base64_re = None # (!) real value is ''

chrset = None # (!) real value is ''

cte = None # (!) real value is ''

File = None # (!) real value is ''

he = None # (!) real value is ''

HeaderFile = None # (!) real value is ''

iso_char = None # (!) real value is ''

mime_char = None # (!) real value is ''

mime_code = None # (!) real value is ''

mime_head = None # (!) real value is ''

mime_header = None # (!) real value is ''

mime_header_char = None # (!) real value is ''

mp = None # (!) real value is ''

mv = None # (!) real value is ''

qp = None # (!) real value is ''

repl = None # (!) real value is ''

__all__ = [
    'mimify',
    'unmimify',
    'mime_encode_header',
    'mime_decode_header',
]

