# encoding: utf-8
# module os2emxpath
# from /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/os2emxpath.pyo by generator 1.99
"""
Common pathname manipulations, OS/2 EMX version.

Instead of importing this module directly, import os and refer to this
module as os.path.
"""

# imports
import stat as stat # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/stat.pyc
import os as os # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/os.pyc

# Variables with simple values

altsep = '\\'

curdir = '.'

defpath = '.;C:\\bin'
devnull = 'nul'

extsep = '.'

pardir = '..'
pathsep = ';'

sep = '/'

supports_unicode_filenames = False

# functions

def abspath(path): # reliably restored by inspect
    """ Return the absolute version of a path """
    pass


def basename(p): # reliably restored by inspect
    """ Returns the final component of a pathname """
    pass


def commonprefix(m): # reliably restored by inspect
    """ Given a list of pathnames, returns the longest common leading component """
    pass


def dirname(p): # reliably restored by inspect
    """ Returns the directory component of a pathname """
    pass


def exists(path): # reliably restored by inspect
    """ Test whether a path exists.  Returns False for broken symbolic links """
    pass


def expanduser(path): # reliably restored by inspect
    """
    Expand ~ and ~user constructs.
    
        If user or $HOME is unknown, do nothing.
    """
    pass


def expandvars(path): # reliably restored by inspect
    """
    Expand shell variables of the forms $var, ${var} and %var%.
    
        Unknown variables are left unchanged.
    """
    pass


def getatime(filename): # reliably restored by inspect
    """ Return the last access time of a file, reported by os.stat(). """
    pass


def getctime(filename): # reliably restored by inspect
    """ Return the metadata change time of a file, reported by os.stat(). """
    pass


def getmtime(filename): # reliably restored by inspect
    """ Return the last modification time of a file, reported by os.stat(). """
    pass


def getsize(filename): # reliably restored by inspect
    """ Return the size of a file, reported by os.stat(). """
    pass


def isabs(s): # reliably restored by inspect
    """ Test whether a path is absolute """
    pass


def isdir(s): # reliably restored by inspect
    """ Return true if the pathname refers to an existing directory. """
    pass


def isfile(path): # reliably restored by inspect
    """ Test whether a path is a regular file """
    pass


def islink(path): # reliably restored by inspect
    """
    Test for symbolic link.
        On WindowsNT/95 and OS/2 always returns false
    """
    pass


def ismount(path): # reliably restored by inspect
    """ Test whether a path is a mount point (defined as root of drive) """
    pass


def join(a, *p): # reliably restored by inspect
    """ Join two or more pathname components, inserting sep as needed """
    pass


def lexists(path): # reliably restored by inspect
    """ Test whether a path exists.  Returns False for broken symbolic links """
    pass


def normcase(s): # reliably restored by inspect
    """
    Normalize case of pathname.
    
        Makes all characters lowercase and all altseps into seps.
    """
    pass


def normpath(path): # reliably restored by inspect
    """ Normalize path, eliminating double slashes, etc. """
    pass


def realpath(path): # reliably restored by inspect
    """ Return the absolute version of a path """
    pass


def split(p): # reliably restored by inspect
    """
    Split a pathname.
    
        Return tuple (head, tail) where tail is everything after the final slash.
        Either part may be empty.
    """
    pass


def splitdrive(p): # reliably restored by inspect
    """
    Split a pathname into drive and path specifiers. Returns a 2-tuple
    "(drive,path)";  either part may be empty
    """
    pass


def splitext(p): # reliably restored by inspect
    """
    Split the extension from a pathname.
    
        Extension is everything from the last dot to the end, ignoring
        leading dots.  Returns "(root, ext)"; ext may be empty.
    """
    pass


def splitunc(p): # reliably restored by inspect
    """
    Split a pathname into UNC mount point and relative path specifiers.
    
        Return a 2-tuple (unc, rest); either part may be empty.
        If unc is not empty, it has the form '//host/mount' (or similar
        using backslashes).  unc+rest is always the input path.
        Paths containing drive letters never have an UNC part.
    """
    pass


def walk(top, func, arg): # reliably restored by inspect
    """
    Directory tree walk with callback function.
    
        For each directory in the directory tree rooted at top (including top
        itself, but excluding '.' and '..'), call func(arg, dirname, fnames).
        dirname is the name of the directory, and fnames a list of the names of
        the files and subdirectories in dirname (excluding '.' and '..').  func
        may modify the fnames list in-place (e.g. via del or slice assignment),
        and walk will only recurse into the subdirectories whose names remain in
        fnames; this can be used to implement a filter, or to impose a specific
        order of visiting.  No semantics are defined for, or required of, arg,
        beyond that arg is always passed to func.  It can be used, e.g., to pass
        a filename pattern, or a mutable object designed to accumulate
        statistics.  Passing None for arg is common.
    """
    pass


# no classes
# variables with complex values

__all__ = [
    'normcase',
    'isabs',
    'join',
    'splitdrive',
    'split',
    'splitext',
    'basename',
    'dirname',
    'commonprefix',
    'getsize',
    'getmtime',
    'getatime',
    'getctime',
    'islink',
    'exists',
    'lexists',
    'isdir',
    'isfile',
    'ismount',
    'walk',
    'expanduser',
    'expandvars',
    'normpath',
    'abspath',
    'splitunc',
    'curdir',
    'pardir',
    'sep',
    'pathsep',
    'defpath',
    'altsep',
    'extsep',
    'devnull',
    'realpath',
    'supports_unicode_filenames',
]

