# encoding: utf-8
# module pimp
# from /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/plat-mac/pimp.pyo by generator 1.99
"""
Package Install Manager for Python.

This is currently a MacOSX-only strawman implementation.
Despite other rumours the name stands for "Packman IMPlementation".

Tools to allow easy installation of packages. The idea is that there is
an online XML database per (platform, python-version) containing packages
known to work with that combination. This module contains tools for getting
and parsing the database, testing whether packages are installed, computing
dependencies and installing packages.

There is a minimal main program that works as a command line tool, but the
intention is that the end user will use this through a GUI.
"""

# imports
import distutils as distutils # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/distutils/__init__.pyc
import subprocess as subprocess # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/subprocess.pyc
import shutil as shutil # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/shutil.pyc
import plistlib as plistlib # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/plistlib.pyc
import tempfile as tempfile # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/tempfile.pyc
import tarfile as tarfile # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/tarfile.pyc
import urllib as urllib # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/urllib.py
import time as time # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/lib-dynload/time.so
import urllib2 as urllib2 # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/urllib2.py
import sys as sys # <module 'sys' (built-in)>
import hashlib as hashlib # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/hashlib.pyc
import urlparse as urlparse # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/urlparse.pyc
import os as os # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/os.pyc

# Variables with simple values

DEFAULT_BUILDDIR = '/tmp'
DEFAULT_DOWNLOADDIR = '/tmp'
DEFAULT_INSTALLDIR = '/Library/Python/2.7/site-packages'

DEFAULT_PIMPDATABASE_FMT = 'http://www.python.org/packman/version-%s/%s-%s-%s-%s-%s.plist'

NO_EXECUTE = 0

PIMP_VERSION = '0.5'

_scriptExc_BadInstalled = 'pimp._scriptExc_BadInstalled'
_scriptExc_NotInstalled = 'pimp._scriptExc_NotInstalled'
_scriptExc_OldInstalled = 'pimp._scriptExc_OldInstalled'

# functions

def getDefaultDatabase(experimental=False): # reliably restored by inspect
    # no doc
    pass


def main(): # reliably restored by inspect
    """ Minimal commandline tool to drive pimp. """
    pass


def warnpy3k(message, category=None, stacklevel=1): # reliably restored by inspect
    """
    Issue a deprecation warning for Python 3.x related changes.
    
        Warnings are omitted unless Python is started with the -3 option.
    """
    pass


def _cmd(output, dir, *cmditems): # reliably restored by inspect
    """ Internal routine to run a shell command in a given directory. """
    pass


def _run(mode, verbose, force, args, prefargs, watcher): # reliably restored by inspect
    """ Engine for the main program """
    pass


# no classes
# variables with complex values

ALLOWED_KEYS = [
    'Name',
    'Version',
    'Flavor',
    'Description',
    'Home-page',
    'Download-URL',
    'Install-test',
    'Install-command',
    'Pre-install-command',
    'Post-install-command',
    'Prerequisites',
    'MD5Sum',
    'User-install-skips',
    'Systemwide-only',
]

ARCHIVE_FORMATS = [
    (
        '.tar.Z',
        None, # (!) forward: PimpTarUnpacker, real value is ''
        None,
    ),
    (
        '.taz',
        '<value is a self-reference, replaced by this string>',
        None,
    ),
    (
        '.tar.gz',
        '<value is a self-reference, replaced by this string>',
        None,
    ),
    (
        '.tgz',
        '<value is a self-reference, replaced by this string>',
        None,
    ),
    (
        '.tar.bz',
        '<value is a self-reference, replaced by this string>',
        None,
    ),
    (
        '.zip',
        None, # (!) forward: PimpCommandUnpacker, real value is ''
        'unzip "%s"',
    ),
]

DEFAULT_FLAVORORDER = [
    'source',
    'binary',
    'installer',
]

PimpCommandUnpacker = None # (!) real value is ''

PimpCurlDownloader = None # (!) real value is ''

PimpDatabase = None # (!) real value is ''

PimpDownloader = None # (!) real value is ''

PimpInstaller = None # (!) real value is ''

PimpPackage = None # (!) real value is ''

PimpPackage_binary = None # (!) real value is ''

PimpPackage_installer = None # (!) real value is ''

PimpPackage_source = None # (!) real value is ''

PimpPreferences = None # (!) real value is ''

PimpTarUnpacker = None # (!) real value is ''

PimpUnpacker = None # (!) real value is ''

PimpUrllibDownloader = None # (!) real value is ''

__all__ = [
    'PimpPreferences',
    'PimpDatabase',
    'PimpPackage',
    'main',
    'getDefaultDatabase',
    'PIMP_VERSION',
    'main',
]

