# encoding: utf-8
# module pprint
# from /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/pprint.pyo by generator 1.99
"""
Support to pretty-print lists, tuples, & dictionaries recursively.

Very simple, but useful, especially in debugging data structures.

Classes
-------

PrettyPrinter()
    Handle pretty-printing operations onto a stream using a configured
    set of formatting parameters.

Functions
---------

pformat()
    Format a Python object into a pretty-printed representation.

pprint()
    Pretty-print a Python object to a stream [default is sys.stdout].

saferepr()
    Generate a 'standard' repr()-like value, but protect against recursive
    data structures.
"""

# imports
import warnings as warnings # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/warnings.pyc
import sys as _sys # <module 'sys' (built-in)>
from cStringIO import _StringIO


# functions

def isreadable(object): # reliably restored by inspect
    """ Determine if saferepr(object) is readable by eval(). """
    pass


def isrecursive(object): # reliably restored by inspect
    """ Determine if object requires a recursive representation. """
    pass


def pformat(object, indent=1, width=80, depth=None): # reliably restored by inspect
    """ Format a Python object into a pretty-printed representation. """
    pass


def pprint(object, stream=None, indent=1, width=80, depth=None): # reliably restored by inspect
    """ Pretty-print a Python object to a stream [default is sys.stdout]. """
    pass


def saferepr(object): # reliably restored by inspect
    """ Version of repr() which can handle recursive data structures. """
    pass


def _commajoin(*args, **kwargs): # real signature unknown
    """
    S.join(iterable) -> string
    
    Return a string which is the concatenation of the strings in the
    iterable.  The separator between elements is S.
    """
    pass


def _id(*args, **kwargs): # real signature unknown
    """
    id(object) -> integer
    
    Return the identity of an object.  This is guaranteed to be unique among
    simultaneously existing objects.  (Hint: it's the object's memory address.)
    """
    pass


def _len(*args, **kwargs): # real signature unknown
    """
    len(object) -> integer
    
    Return the number of items of a sequence or mapping.
    """
    pass


def _perfcheck(object=None): # reliably restored by inspect
    # no doc
    pass


def _recursion(object): # reliably restored by inspect
    # no doc
    pass


def _safe_repr(object, context, maxlevels, level): # reliably restored by inspect
    # no doc
    pass


def _sorted(iterable): # reliably restored by inspect
    # no doc
    pass


# classes

class _type(object):
    """
    type(object) -> the object's type
    type(name, bases, dict) -> a new type
    """
    def mro(self): # real signature unknown; restored from __doc__
        """
        mro() -> list
        return a type's method resolution order
        """
        return []

    def __base__(self, *args, **kwargs): # real signature unknown
        """ The most base type """
        pass

    def __call__(self, *more): # real signature unknown; restored from __doc__
        """ x.__call__(...) <==> x(...) """
        pass

    def __delattr__(self, name): # real signature unknown; restored from __doc__
        """ x.__delattr__('name') <==> del x.name """
        pass

    def __eq__(self, y): # real signature unknown; restored from __doc__
        """ x.__eq__(y) <==> x==y """
        pass

    def __getattribute__(self, name): # real signature unknown; restored from __doc__
        """ x.__getattribute__('name') <==> x.name """
        pass

    def __ge__(self, y): # real signature unknown; restored from __doc__
        """ x.__ge__(y) <==> x>=y """
        pass

    def __gt__(self, y): # real signature unknown; restored from __doc__
        """ x.__gt__(y) <==> x>y """
        pass

    def __hash__(self): # real signature unknown; restored from __doc__
        """ x.__hash__() <==> hash(x) """
        pass

    def __init__(self, p_object): # real signature unknown; restored from __doc__
        pass

    def __instancecheck__(self): # real signature unknown; restored from __doc__
        """ __instancecheck__() -> check if an object is an instance """
        pass

    def __le__(self, y): # real signature unknown; restored from __doc__
        """ x.__le__(y) <==> x<=y """
        pass

    def __lt__(self, y): # real signature unknown; restored from __doc__
        """ x.__lt__(y) <==> x<y """
        pass

    @staticmethod # known case of __new__
    def __new__(S, *more): # real signature unknown; restored from __doc__
        """ T.__new__(S, ...) -> a new object with type S, a subtype of T """
        pass

    def __ne__(self, y): # real signature unknown; restored from __doc__
        """ x.__ne__(y) <==> x!=y """
        pass

    def __repr__(self): # real signature unknown; restored from __doc__
        """ x.__repr__() <==> repr(x) """
        pass

    def __setattr__(self, name, value): # real signature unknown; restored from __doc__
        """ x.__setattr__('name', value) <==> x.name = value """
        pass

    def __subclasscheck__(self): # real signature unknown; restored from __doc__
        """ __subclasscheck__() -> check if a class is a subclass """
        pass

    def __subclasses__(self): # real signature unknown; restored from __doc__
        """ __subclasses__() -> list of immediate subclasses """
        return []

    __abstractmethods__ = property(lambda self: object()) # default

    __bases__ = (
        object,
    )
    __basicsize__ = 872
    __dictoffset__ = 264
    __dict__ = None # (!) real value is ''
    __flags__ = 2148423147
    __itemsize__ = 40
    __mro__ = (
        type,
        object,
    )
    __name__ = 'type'
    __weakrefoffset__ = 368


# variables with complex values

PrettyPrinter = None # (!) real value is ''

__all__ = [
    'pprint',
    'pformat',
    'isreadable',
    'isrecursive',
    'saferepr',
    'PrettyPrinter',
]

