# encoding: utf-8
# module pydoc
# from /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/pydoc.pyo by generator 1.99
"""
Generate Python documentation in HTML or text for interactive use.

In the Python interpreter, do "from pydoc import help" to provide online
help.  Calling help(thing) on a Python object documents the object.

Or, at the shell command line outside of Python:

Run "pydoc <name>" to show documentation on something.  <name> may be
the name of a function, module, package, or a dotted reference to a
class or function within a module or module in a package.  If the
argument contains a path segment delimiter (e.g. slash on Unix,
backslash on Windows) it is treated as the path to a Python source file.

Run "pydoc -k <keyword>" to search for a keyword in the synopsis lines
of all available modules.

Run "pydoc -p <port>" to start an HTTP server on a given port on the
local machine to generate documentation web pages.

For platforms without a command line, "pydoc -g" starts the HTTP server
and also pops up a little window for controlling it.

Run "pydoc -w <name>" to write out the HTML documentation for a module
to a file named "<name>.html".

Module docs for core modules are assumed to be in

    http://docs.python.org/library/

This can be overridden by setting the PYTHONDOCS environment variable
to a different URL or to a local directory containing the Library
Reference Manual pages.
"""

# imports
import __builtin__ as __builtin__ # <module '__builtin__' (built-in)>
import pkgutil as pkgutil # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/pkgutil.pyc
import imp as imp # <module 'imp' (built-in)>
import re as re # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/re.pyc
import inspect as inspect # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/inspect.pyc
import sys as sys # <module 'sys' (built-in)>
import types as types # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/types.pyc
import os as os # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/os.pyc

# Variables with simple values

__author__ = 'Ka-Ping Yee <ping@lfw.org>'

__credits__ = 'Guido van Rossum, for an excellent programming language.\nTommy Burnette, the original creator of manpy.\nPaul Prescod, for all his work on onlinehelp.\nRichard Chamberlain, for the first implementation of textdoc.\n'

__date__ = '26 February 2001'

__version__ = '$Revision: 84174 $'

# functions

def allmethods(cl): # reliably restored by inspect
    # no doc
    pass


def apropos(key): # reliably restored by inspect
    """ Print all the one-line module summaries that contain a substring. """
    pass


def classify_class_attrs(object): # reliably restored by inspect
    """ Wrap inspect.classify_class_attrs, with fixup for data descriptors. """
    pass


def classname(object, modname): # reliably restored by inspect
    """ Get a class name and qualify it with a module name if necessary. """
    pass


def cli(): # reliably restored by inspect
    """ Command-line interface (looks at sys.argv to decide what to do). """
    pass


def cram(text, maxlen): # reliably restored by inspect
    """ Omit part of a string if needed to make it fit in a maximum length. """
    pass


def describe(thing): # reliably restored by inspect
    """ Produce a short description of the given thing. """
    pass


def doc(thing, title=None, forceload=0): # reliably restored by inspect
    """ Display text documentation, given an object or a path to an object. """
    pass


def expandtabs(s, tabsize=8): # reliably restored by inspect
    """
    expandtabs(s [,tabsize]) -> string
    
        Return a copy of the string s with all tab characters replaced
        by the appropriate number of spaces, depending on the current
        column, and the tabsize (default 8).
    """
    pass


def extract_tb(tb, limit=None): # reliably restored by inspect
    """
    Return list of up to limit pre-processed entries from traceback.
    
        This is useful for alternate formatting of stack traces.  If
        'limit' is omitted or None, all entries are extracted.  A
        pre-processed stack trace entry is a quadruple (filename, line
        number, function name, text) representing the information that is
        usually printed for a stack trace.  The text is a string with
        leading and trailing whitespace stripped; if the source is not
        available it is None.
    """
    pass


def find(s, *args): # reliably restored by inspect
    """
    find(s, sub [,start [,end]]) -> in
    
        Return the lowest index in s where substring sub is found,
        such that sub is contained within s[start,end].  Optional
        arguments start and end are interpreted as in slice notation.
    
        Return -1 on failure.
    """
    pass


def getdoc(object): # reliably restored by inspect
    """ Get the doc string or comments for an object. """
    pass


def getpager(): # reliably restored by inspect
    """ Decide what method to use for paging through text. """
    pass


def gui(): # reliably restored by inspect
    """ Graphical interface (starts web server and pops up a control window). """
    pass


def help(*args, **kwargs): # real signature unknown
    pass


def Helper(*args, **kwargs): # real signature unknown
    pass


def importfile(path): # reliably restored by inspect
    """ Import a Python source file or compiled file given its path. """
    pass


def isdata(object): # reliably restored by inspect
    """ Check if an object is of a type that probably means it's data. """
    pass


def ispackage(path): # reliably restored by inspect
    """ Guess whether a path refers to a package directory. """
    pass


def ispath(x): # reliably restored by inspect
    # no doc
    pass


def join(words, sep=None): # reliably restored by inspect
    """
    join(list [,sep]) -> string
    
        Return a string composed of the words in list, with
        intervening occurrences of sep.  The default separator is a
        single space.
    
        (joinfields and join are synonymous)
    """
    pass


def locate(path, forceload=0): # reliably restored by inspect
    """ Locate an object by name or dotted path, importing as necessary. """
    pass


def lower(s): # reliably restored by inspect
    """
    lower(s) -> string
    
        Return a copy of the string s converted to lowercase.
    """
    pass


def pager(text): # reliably restored by inspect
    """ The first time this is called, determine what kind of pager to use. """
    pass


def pathdirs(): # reliably restored by inspect
    """ Convert sys.path into a list of absolute, existing, unique paths. """
    pass


def pipepager(text, cmd): # reliably restored by inspect
    """ Page through text by feeding it to another program. """
    pass


def plain(text): # reliably restored by inspect
    """ Remove boldface formatting from text. """
    pass


def plainpager(text): # reliably restored by inspect
    """ Simply print unformatted text.  This is the ultimate fallback. """
    pass


def render_doc(thing, title=None, forceload=0): # reliably restored by inspect
    """ Render text documentation, given an object or a path to an object. """
    pass


def replace(text, *pairs): # reliably restored by inspect
    """ Do a series of global replacements on a string. """
    pass


def resolve(thing, forceload=0): # reliably restored by inspect
    """ Given an object or a path to an object, get the object and its name. """
    pass


def rfind(s, *args): # reliably restored by inspect
    """
    rfind(s, sub [,start [,end]]) -> int
    
        Return the highest index in s where substring sub is found,
        such that sub is contained within s[start,end].  Optional
        arguments start and end are interpreted as in slice notation.
    
        Return -1 on failure.
    """
    pass


def rstrip(s, chars=None): # reliably restored by inspect
    """
    rstrip(s [,chars]) -> string
    
        Return a copy of the string s with trailing whitespace removed.
        If chars is given and not None, remove characters in chars instead.
    """
    pass


def safeimport(path, forceload=0, cache='{}'): # reliably restored by inspect
    """
    Import a module; handle errors; return None if the module isn't found.
    
        If the module *is* found but an exception occurs, it's wrapped in an
        ErrorDuringImport exception and reraised.  Unlike __import__, if a
        package path is specified, the module at the end of the path is returned,
        not the package at the beginning.  If the optional 'forceload' argument
        is 1, we reload the module from disk (unless it's a dynamic extension).
    """
    pass


def serve(port, callback=None, completer=None): # reliably restored by inspect
    # no doc
    pass


def source_synopsis(file): # reliably restored by inspect
    # no doc
    pass


def split(s, sep=None, maxsplit=-1): # reliably restored by inspect
    """
    split(s [,sep [,maxsplit]]) -> list of strings
    
        Return a list of the words in the string s, using sep as the
        delimiter string.  If maxsplit is given, splits at no more than
        maxsplit places (resulting in at most maxsplit+1 words).  If sep
        is not specified or is None, any whitespace string is a separator.
    
        (split and splitfields are synonymous)
    """
    pass


def splitdoc(doc): # reliably restored by inspect
    """ Split a doc string into a synopsis line (if any) and the rest. """
    pass


def strip(s, chars=None): # reliably restored by inspect
    """
    strip(s [,chars]) -> string
    
        Return a copy of the string s with leading and trailing
        whitespace removed.
        If chars is given and not None, remove characters in chars instead.
        If chars is unicode, S will be converted to unicode before stripping.
    """
    pass


def stripid(text): # reliably restored by inspect
    """ Remove the hexadecimal id from a Python object representation. """
    pass


def synopsis(filename, cache='{}'): # reliably restored by inspect
    """ Get the one-line summary out of a module file. """
    pass


def tempfilepager(text, cmd): # reliably restored by inspect
    """ Page through text by invoking a program on a temporary file. """
    pass


def ttypager(text): # reliably restored by inspect
    """ Page through text on a text terminal. """
    pass


def visiblename(name, all=None): # reliably restored by inspect
    """ Decide whether to show documentation on a variable. """
    pass


def writedoc(thing, forceload=0): # reliably restored by inspect
    """ Write HTML documentation to a file in the current directory. """
    pass


def writedocs(dir, pkgpath=None, done=None): # reliably restored by inspect
    """ Write out HTML documentation for all modules in a directory tree. """
    pass


def _is_some_method(obj): # reliably restored by inspect
    # no doc
    pass


def _split_list(s, predicate): # reliably restored by inspect
    """
    Split sequence s via predicate, and return pair ([true], [false]).
    
        The return value is a 2-tuple of lists,
            ([x for x in s if predicate(x)],
             [x for x in s if not predicate(x)])
    """
    pass


# classes

class deque(object):
    """
    deque(iterable[, maxlen]) --> deque object
    
    Build an ordered collection accessible from endpoints only.
    """
    def append(self, *args, **kwargs): # real signature unknown
        """ Add an element to the right side of the deque. """
        pass

    def appendleft(self, *args, **kwargs): # real signature unknown
        """ Add an element to the left side of the deque. """
        pass

    def clear(self, *args, **kwargs): # real signature unknown
        """ Remove all elements from the deque. """
        pass

    def count(self, value): # real signature unknown; restored from __doc__
        """ D.count(value) -> integer -- return number of occurrences of value """
        return 0

    def extend(self, *args, **kwargs): # real signature unknown
        """ Extend the right side of the deque with elements from the iterable """
        pass

    def extendleft(self, *args, **kwargs): # real signature unknown
        """ Extend the left side of the deque with elements from the iterable """
        pass

    def pop(self, *args, **kwargs): # real signature unknown
        """ Remove and return the rightmost element. """
        pass

    def popleft(self, *args, **kwargs): # real signature unknown
        """ Remove and return the leftmost element. """
        pass

    def remove(self, value): # real signature unknown; restored from __doc__
        """ D.remove(value) -- remove first occurrence of value. """
        pass

    def reverse(self): # real signature unknown; restored from __doc__
        """ D.reverse() -- reverse *IN PLACE* """
        pass

    def rotate(self, *args, **kwargs): # real signature unknown
        """ Rotate the deque n steps to the right (default n=1).  If n is negative, rotates left. """
        pass

    def __copy__(self, *args, **kwargs): # real signature unknown
        """ Return a shallow copy of a deque. """
        pass

    def __delitem__(self, y): # real signature unknown; restored from __doc__
        """ x.__delitem__(y) <==> del x[y] """
        pass

    def __eq__(self, y): # real signature unknown; restored from __doc__
        """ x.__eq__(y) <==> x==y """
        pass

    def __getattribute__(self, name): # real signature unknown; restored from __doc__
        """ x.__getattribute__('name') <==> x.name """
        pass

    def __getitem__(self, y): # real signature unknown; restored from __doc__
        """ x.__getitem__(y) <==> x[y] """
        pass

    def __ge__(self, y): # real signature unknown; restored from __doc__
        """ x.__ge__(y) <==> x>=y """
        pass

    def __gt__(self, y): # real signature unknown; restored from __doc__
        """ x.__gt__(y) <==> x>y """
        pass

    def __iadd__(self, y): # real signature unknown; restored from __doc__
        """ x.__iadd__(y) <==> x+=y """
        pass

    def __init__(self, iterable, maxlen=None): # real signature unknown; restored from __doc__
        pass

    def __iter__(self): # real signature unknown; restored from __doc__
        """ x.__iter__() <==> iter(x) """
        pass

    def __len__(self): # real signature unknown; restored from __doc__
        """ x.__len__() <==> len(x) """
        pass

    def __le__(self, y): # real signature unknown; restored from __doc__
        """ x.__le__(y) <==> x<=y """
        pass

    def __lt__(self, y): # real signature unknown; restored from __doc__
        """ x.__lt__(y) <==> x<y """
        pass

    @staticmethod # known case of __new__
    def __new__(S, *more): # real signature unknown; restored from __doc__
        """ T.__new__(S, ...) -> a new object with type S, a subtype of T """
        pass

    def __ne__(self, y): # real signature unknown; restored from __doc__
        """ x.__ne__(y) <==> x!=y """
        pass

    def __reduce__(self, *args, **kwargs): # real signature unknown
        """ Return state information for pickling. """
        pass

    def __repr__(self): # real signature unknown; restored from __doc__
        """ x.__repr__() <==> repr(x) """
        pass

    def __reversed__(self): # real signature unknown; restored from __doc__
        """ D.__reversed__() -- return a reverse iterator over the deque """
        pass

    def __setitem__(self, i, y): # real signature unknown; restored from __doc__
        """ x.__setitem__(i, y) <==> x[i]=y """
        pass

    maxlen = property(lambda self: object()) # default

    __hash__ = None


class ErrorDuringImport(Exception):
    """ Errors that occurred while trying to import something to document it. """
    def __init__(self, *args, **kwargs): # real signature unknown
        pass

    def __str__(self, *args, **kwargs): # real signature unknown
        pass

    __weakref__ = property(lambda self: object()) # default


class _OLD_INSTANCE_TYPE(object):
    """
    instance(class[, dict])
    
    Create an instance without calling its __init__() method.
    The class must be a classic class.
    If present, dict must be a dictionary or None.
    """
    def next(self): # real signature unknown; restored from __doc__
        """ x.next() -> the next value, or raise StopIteration """
        pass

    def __abs__(self): # real signature unknown; restored from __doc__
        """ x.__abs__() <==> abs(x) """
        pass

    def __add__(self, y): # real signature unknown; restored from __doc__
        """ x.__add__(y) <==> x+y """
        pass

    def __and__(self, y): # real signature unknown; restored from __doc__
        """ x.__and__(y) <==> x&y """
        pass

    def __call__(self, *more): # real signature unknown; restored from __doc__
        """ x.__call__(...) <==> x(...) """
        pass

    def __cmp__(self, y): # real signature unknown; restored from __doc__
        """ x.__cmp__(y) <==> cmp(x,y) """
        pass

    def __coerce__(self, y): # real signature unknown; restored from __doc__
        """ x.__coerce__(y) <==> coerce(x, y) """
        pass

    def __contains__(self, y): # real signature unknown; restored from __doc__
        """ x.__contains__(y) <==> y in x """
        pass

    def __delattr__(self, name): # real signature unknown; restored from __doc__
        """ x.__delattr__('name') <==> del x.name """
        pass

    def __delitem__(self, y): # real signature unknown; restored from __doc__
        """ x.__delitem__(y) <==> del x[y] """
        pass

    def __delslice__(self, i, j): # real signature unknown; restored from __doc__
        """
        x.__delslice__(i, j) <==> del x[i:j]
                   
                   Use of negative indices is not supported.
        """
        pass

    def __divmod__(self, y): # real signature unknown; restored from __doc__
        """ x.__divmod__(y) <==> divmod(x, y) """
        pass

    def __div__(self, y): # real signature unknown; restored from __doc__
        """ x.__div__(y) <==> x/y """
        pass

    def __eq__(self, y): # real signature unknown; restored from __doc__
        """ x.__eq__(y) <==> x==y """
        pass

    def __float__(self): # real signature unknown; restored from __doc__
        """ x.__float__() <==> float(x) """
        pass

    def __floordiv__(self, y): # real signature unknown; restored from __doc__
        """ x.__floordiv__(y) <==> x//y """
        pass

    def __getattribute__(self, name): # real signature unknown; restored from __doc__
        """ x.__getattribute__('name') <==> x.name """
        pass

    def __getitem__(self, y): # real signature unknown; restored from __doc__
        """ x.__getitem__(y) <==> x[y] """
        pass

    def __getslice__(self, i, j): # real signature unknown; restored from __doc__
        """
        x.__getslice__(i, j) <==> x[i:j]
                   
                   Use of negative indices is not supported.
        """
        pass

    def __ge__(self, y): # real signature unknown; restored from __doc__
        """ x.__ge__(y) <==> x>=y """
        pass

    def __gt__(self, y): # real signature unknown; restored from __doc__
        """ x.__gt__(y) <==> x>y """
        pass

    def __hash__(self): # real signature unknown; restored from __doc__
        """ x.__hash__() <==> hash(x) """
        pass

    def __hex__(self): # real signature unknown; restored from __doc__
        """ x.__hex__() <==> hex(x) """
        pass

    def __iadd__(self, y): # real signature unknown; restored from __doc__
        """ x.__iadd__(y) <==> x+y """
        pass

    def __iand__(self, y): # real signature unknown; restored from __doc__
        """ x.__iand__(y) <==> x&y """
        pass

    def __idiv__(self, y): # real signature unknown; restored from __doc__
        """ x.__idiv__(y) <==> x/y """
        pass

    def __ifloordiv__(self, y): # real signature unknown; restored from __doc__
        """ x.__ifloordiv__(y) <==> x//y """
        pass

    def __ilshift__(self, y): # real signature unknown; restored from __doc__
        """ x.__ilshift__(y) <==> x<<y """
        pass

    def __imod__(self, y): # real signature unknown; restored from __doc__
        """ x.__imod__(y) <==> x%y """
        pass

    def __imul__(self, y): # real signature unknown; restored from __doc__
        """ x.__imul__(y) <==> x*y """
        pass

    def __index__(self): # real signature unknown; restored from __doc__
        """ x[y:z] <==> x[y.__index__():z.__index__()] """
        pass

    def __init__(self): # real signature unknown; restored from __doc__
        pass

    def __int__(self): # real signature unknown; restored from __doc__
        """ x.__int__() <==> int(x) """
        pass

    def __invert__(self): # real signature unknown; restored from __doc__
        """ x.__invert__() <==> ~x """
        pass

    def __ior__(self, y): # real signature unknown; restored from __doc__
        """ x.__ior__(y) <==> x|y """
        pass

    def __ipow__(self, y): # real signature unknown; restored from __doc__
        """ x.__ipow__(y) <==> x**y """
        pass

    def __irshift__(self, y): # real signature unknown; restored from __doc__
        """ x.__irshift__(y) <==> x>>y """
        pass

    def __isub__(self, y): # real signature unknown; restored from __doc__
        """ x.__isub__(y) <==> x-y """
        pass

    def __iter__(self): # real signature unknown; restored from __doc__
        """ x.__iter__() <==> iter(x) """
        pass

    def __itruediv__(self, y): # real signature unknown; restored from __doc__
        """ x.__itruediv__(y) <==> x/y """
        pass

    def __ixor__(self, y): # real signature unknown; restored from __doc__
        """ x.__ixor__(y) <==> x^y """
        pass

    def __len__(self): # real signature unknown; restored from __doc__
        """ x.__len__() <==> len(x) """
        pass

    def __le__(self, y): # real signature unknown; restored from __doc__
        """ x.__le__(y) <==> x<=y """
        pass

    def __long__(self): # real signature unknown; restored from __doc__
        """ x.__long__() <==> long(x) """
        pass

    def __lshift__(self, y): # real signature unknown; restored from __doc__
        """ x.__lshift__(y) <==> x<<y """
        pass

    def __lt__(self, y): # real signature unknown; restored from __doc__
        """ x.__lt__(y) <==> x<y """
        pass

    def __mod__(self, y): # real signature unknown; restored from __doc__
        """ x.__mod__(y) <==> x%y """
        pass

    def __mul__(self, y): # real signature unknown; restored from __doc__
        """ x.__mul__(y) <==> x*y """
        pass

    def __neg__(self): # real signature unknown; restored from __doc__
        """ x.__neg__() <==> -x """
        pass

    @staticmethod # known case of __new__
    def __new__(S, *more): # real signature unknown; restored from __doc__
        """ T.__new__(S, ...) -> a new object with type S, a subtype of T """
        pass

    def __ne__(self, y): # real signature unknown; restored from __doc__
        """ x.__ne__(y) <==> x!=y """
        pass

    def __nonzero__(self): # real signature unknown; restored from __doc__
        """ x.__nonzero__() <==> x != 0 """
        pass

    def __oct__(self): # real signature unknown; restored from __doc__
        """ x.__oct__() <==> oct(x) """
        pass

    def __or__(self, y): # real signature unknown; restored from __doc__
        """ x.__or__(y) <==> x|y """
        pass

    def __pos__(self): # real signature unknown; restored from __doc__
        """ x.__pos__() <==> +x """
        pass

    def __pow__(self, y, z=None): # real signature unknown; restored from __doc__
        """ x.__pow__(y[, z]) <==> pow(x, y[, z]) """
        pass

    def __radd__(self, y): # real signature unknown; restored from __doc__
        """ x.__radd__(y) <==> y+x """
        pass

    def __rand__(self, y): # real signature unknown; restored from __doc__
        """ x.__rand__(y) <==> y&x """
        pass

    def __rdivmod__(self, y): # real signature unknown; restored from __doc__
        """ x.__rdivmod__(y) <==> divmod(y, x) """
        pass

    def __rdiv__(self, y): # real signature unknown; restored from __doc__
        """ x.__rdiv__(y) <==> y/x """
        pass

    def __repr__(self): # real signature unknown; restored from __doc__
        """ x.__repr__() <==> repr(x) """
        pass

    def __rfloordiv__(self, y): # real signature unknown; restored from __doc__
        """ x.__rfloordiv__(y) <==> y//x """
        pass

    def __rlshift__(self, y): # real signature unknown; restored from __doc__
        """ x.__rlshift__(y) <==> y<<x """
        pass

    def __rmod__(self, y): # real signature unknown; restored from __doc__
        """ x.__rmod__(y) <==> y%x """
        pass

    def __rmul__(self, y): # real signature unknown; restored from __doc__
        """ x.__rmul__(y) <==> y*x """
        pass

    def __ror__(self, y): # real signature unknown; restored from __doc__
        """ x.__ror__(y) <==> y|x """
        pass

    def __rpow__(self, x, z=None): # real signature unknown; restored from __doc__
        """ y.__rpow__(x[, z]) <==> pow(x, y[, z]) """
        pass

    def __rrshift__(self, y): # real signature unknown; restored from __doc__
        """ x.__rrshift__(y) <==> y>>x """
        pass

    def __rshift__(self, y): # real signature unknown; restored from __doc__
        """ x.__rshift__(y) <==> x>>y """
        pass

    def __rsub__(self, y): # real signature unknown; restored from __doc__
        """ x.__rsub__(y) <==> y-x """
        pass

    def __rtruediv__(self, y): # real signature unknown; restored from __doc__
        """ x.__rtruediv__(y) <==> y/x """
        pass

    def __rxor__(self, y): # real signature unknown; restored from __doc__
        """ x.__rxor__(y) <==> y^x """
        pass

    def __setattr__(self, name, value): # real signature unknown; restored from __doc__
        """ x.__setattr__('name', value) <==> x.name = value """
        pass

    def __setitem__(self, i, y): # real signature unknown; restored from __doc__
        """ x.__setitem__(i, y) <==> x[i]=y """
        pass

    def __setslice__(self, i, j, y): # real signature unknown; restored from __doc__
        """
        x.__setslice__(i, j, y) <==> x[i:j]=y
                   
                   Use  of negative indices is not supported.
        """
        pass

    def __str__(self): # real signature unknown; restored from __doc__
        """ x.__str__() <==> str(x) """
        pass

    def __sub__(self, y): # real signature unknown; restored from __doc__
        """ x.__sub__(y) <==> x-y """
        pass

    def __truediv__(self, y): # real signature unknown; restored from __doc__
        """ x.__truediv__(y) <==> x/y """
        pass

    def __xor__(self, y): # real signature unknown; restored from __doc__
        """ x.__xor__(y) <==> x^y """
        pass


# variables with complex values

Doc = None # (!) real value is ''

html = None # (!) real value is ''

HTMLDoc = None # (!) real value is ''

HTMLRepr = None # (!) real value is ''

ModuleScanner = None # (!) real value is ''

Repr = None # (!) real value is ''

Scanner = None # (!) real value is ''

text = None # (!) real value is ''

TextDoc = None # (!) real value is ''

TextRepr = None # (!) real value is ''

_OldStyleClass = None # (!) real value is ''

_re_stripid = None # (!) real value is ''

