# encoding: utf-8
# module runpy
# from /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/runpy.pyo by generator 1.99
"""
runpy.py - locating and running Python code using the module namespace

Provides support for locating and running Python scripts using the Python
module namespace instead of the native filesystem.

This allows Python code to play nicely with non-filesystem based PEP 302
importers when locating support scripts as well as when importing modules.
"""

# imports
import imp as imp # <module 'imp' (built-in)>
import sys as sys # <module 'sys' (built-in)>

# functions

def get_loader(module_or_name): # reliably restored by inspect
    """
    Get a PEP 302 "loader" object for module_or_name
    
        If the module or package is accessible via the normal import
        mechanism, a wrapper around the relevant part of that machinery
        is returned.  Returns None if the module cannot be found or imported.
        If the named module is not already imported, its containing package
        (if any) is imported, in order to establish the package __path__.
    
        This function uses iter_importers(), and is thus subject to the same
        limitations regarding platform-specific special import locations such
        as the Windows registry.
    """
    pass


def read_code(stream): # reliably restored by inspect
    # no doc
    pass


def run_module(mod_name, init_globals=None, run_name=None, alter_sys=False): # reliably restored by inspect
    """
    Execute a module's code without importing it
    
           Returns the resulting top level namespace dictionary
    """
    pass


def run_path(path_name, init_globals=None, run_name=None): # reliably restored by inspect
    """
    Execute code located at the specified filesystem location
    
           Returns the resulting top level namespace dictionary
    
           The file path may refer directly to a Python script (i.e.
           one that could be directly executed with execfile) or else
           it may refer to a zipfile or directory containing a top
           level __main__.py script.
    """
    pass


def _get_code_from_file(fname): # reliably restored by inspect
    # no doc
    pass


def _get_filename(loader, mod_name): # reliably restored by inspect
    # no doc
    pass


def _get_importer(path_name): # reliably restored by inspect
    """ Python version of PyImport_GetImporter C API function """
    pass


def _get_main_module_details(): # reliably restored by inspect
    # no doc
    pass


def _get_module_details(mod_name): # reliably restored by inspect
    # no doc
    pass


def _run_code(code, run_globals, init_globals=None, mod_name=None, mod_fname=None, mod_loader=None, pkg_name=None): # reliably restored by inspect
    """ Helper to run code in nominated namespace """
    pass


def _run_module_as_main(mod_name, alter_argv=True): # reliably restored by inspect
    """
    Runs the designated module in the __main__ namespace
    
           Note that the executed module will have full access to the
           __main__ namespace. If this is not desirable, the run_module()
           function should be used to run the module code in a fresh namespace.
    
           At the very least, these variables in __main__ will be overwritten:
               __name__
               __file__
               __loader__
               __package__
    """
    pass


def _run_module_code(code, init_globals=None, mod_name=None, mod_fname=None, mod_loader=None, pkg_name=None): # reliably restored by inspect
    """ Helper to run code in new namespace with sys modified """
    pass


# classes

class _ModifiedArgv0(object):
    # no doc
    def __enter__(self, *args, **kwargs): # real signature unknown
        pass

    def __exit__(self, *args, **kwargs): # real signature unknown
        pass

    def __init__(self, *args, **kwargs): # real signature unknown
        pass

    __weakref__ = property(lambda self: object()) # default

    __dict__ = None # (!) real value is ''


class _TempModule(object):
    """ Temporarily replace a module in sys.modules with an empty namespace """
    def __enter__(self, *args, **kwargs): # real signature unknown
        pass

    def __exit__(self, *args, **kwargs): # real signature unknown
        pass

    def __init__(self, *args, **kwargs): # real signature unknown
        pass

    __weakref__ = property(lambda self: object()) # default

    __dict__ = None # (!) real value is ''


# variables with complex values

__all__ = [
    'run_module',
    'run_path',
]

