# encoding: utf-8
# module trace
# from /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/trace.pyo by generator 1.99
"""
program/module to trace Python program or function execution

Sample use, command line:
  trace.py -c -f counts --ignore-dir '$prefix' spam.py eggs
  trace.py -t --ignore-dir '$prefix' spam.py eggs
  trace.py --trackcalls spam.py eggs

Sample use, programmatically
  import sys

  # create a Trace object, telling it what to ignore, and whether to
  # do tracing or line-counting or both.
  tracer = trace.Trace(ignoredirs=[sys.prefix, sys.exec_prefix,], trace=0,
                    count=1)
  # run the new command using the given tracer
  tracer.run('main()')
  # make a report, placing output in /tmp
  r = tracer.results()
  r.write_results(show_missing=True, coverdir="/tmp")
"""

# imports
import gc as gc # <module 'gc' (built-in)>
import threading as threading # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/threading.pyc
import re as re # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/re.pyc
import tokenize as tokenize # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/tokenize.pyc
import cPickle as cPickle # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/lib-dynload/cPickle.so
import inspect as inspect # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/inspect.pyc
import sys as sys # <module 'sys' (built-in)>
import os as os # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/os.pyc
import linecache as linecache # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/linecache.pyc
import token as token # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/token.pyc
import time as time # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/lib-dynload/time.so
import cPickle as pickle # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/lib-dynload/cPickle.so
import dis as dis # /System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/dis.pyc

# Variables with simple values

PRAGMA_NOCOVER = '#pragma NO COVER'

# functions

def find_executable_linenos(filename): # reliably restored by inspect
    """ Return dict where keys are line numbers in the line number table. """
    pass


def find_lines(code, strs): # reliably restored by inspect
    """ Return lineno dict for all code objects reachable from code. """
    pass


def find_lines_from_code(code, strs): # reliably restored by inspect
    """ Return dict where keys are lines in the line number table. """
    pass


def find_strings(filename): # reliably restored by inspect
    """
    Return a dict of possible docstring positions.
    
        The dict maps line numbers to strings.  There is an entry for
        line that contains only a string or a part of a triple-quoted
        string.
    """
    pass


def fullmodname(path): # reliably restored by inspect
    """ Return a plausible module name for the path. """
    pass


def main(argv=None): # reliably restored by inspect
    # no doc
    pass


def modname(path): # reliably restored by inspect
    """ Return a plausible module name for the patch. """
    pass


def usage(outfile): # reliably restored by inspect
    # no doc
    pass


def _err_exit(msg): # reliably restored by inspect
    # no doc
    pass


def _settrace(func): # reliably restored by inspect
    # no doc
    pass


def _unsettrace(): # reliably restored by inspect
    # no doc
    pass


# no classes
# variables with complex values

CoverageResults = None # (!) real value is ''

Ignore = None # (!) real value is ''

rx_blank = None # (!) real value is ''

Trace = None # (!) real value is ''

